import * as R from 'ramda'
import { recover } from '../recover/recover'
import { splitByPage } from '../splitByPage/splitByPage'
import { splitByPoint } from '../splitByPoint/splitByPoint'


export const adaptate = async (docHtml: string) => {

  const afterRecover = await recover(docHtml)
  const afterSplitByPoint = splitByPoint(afterRecover)
  const afterSplitPage: string[] = []

  await afterSplitByPoint.reduce(async (promise, doc) => (
    promise.then(async () => {
      const pages = await splitByPage(doc)
      afterSplitPage.push(pages)
    })
  ), Promise.resolve())

  return afterSplitPage
}