import * as  R from 'ramda'
import * as utils from '../utils'
import { insertMeta } from './insertMeta'
import { replaceStyle } from './replaceStyle'
import { splitTableRow } from './splitTableRow'

export const recover = async (docHtml: string) => {

  const resHtml = await R.compose(
    R.andThen((dom: HTMLDivElement) => dom.querySelector('html')?.outerHTML!),
    R.andThen(splitTableRow),
    R.andThen(insertMeta),
    async (docHtml) => await utils.createHiddenDom(docHtml),
    replaceStyle
  )(docHtml)

  utils.removeHiddenDom()

  return resHtml
}