import { EOrientation } from '../types'
import { MIN_WIDTH_CELL_ENTITY } from "./constant"
import { CellEntity, TableElement } from "./type"

export class TableUtils {
  // Создает  элемент для таблицы хедер,боди,строку или ячейку
  static createTableElement(type: TableElement) {
    const divElement = document.createElement('div')
    divElement.classList.add(type)
    return divElement
  }

  static getCellType(cell: HTMLDivElement): CellEntity {
    if (cell.querySelector('.signer') || cell.querySelector('.user'))
      return 'user'
    if (cell.querySelector('.location'))
      return 'location'
    if (cell.querySelector('.text') || cell.querySelector('.text_options'))
      return 'text'
    if (!cell.children.length && cell.childNodes[0].TEXT_NODE)
      return 'numbering'
    if (cell.querySelector('.date'))
      return 'date'
    if (cell.querySelector('.time'))
      return 'time'
    if (cell.querySelector('.datetime'))
      return 'detetime'
    if (cell.querySelector('.company'))
      return 'company'
    return 'other'
  }

  static getTableElement(tableElement: HTMLDivElement, selector: string) {
    return [...tableElement.querySelectorAll(`${selector}`) ?? []]
  }

  static getMinWidthForEntityCells(entity: CellEntity[], orientation: EOrientation): number[] {
    return entity.map((entity) => MIN_WIDTH_CELL_ENTITY[entity])
  }
}
