import { EOrientation } from '../types'
import { Pages } from './Pages'
import R from 'ramda'

import * as utils from '../utils'

export const splitByPage = async (docHtml: string): Promise<string> => {
  const docHtmlDOM = await utils.createHiddenDom(docHtml)
  const allRowElems = [...(docHtmlDOM.querySelector('.template-constructor')?.children ?? [])] as HTMLDivElement[]
  const orientation = docHtmlDOM.querySelector('.template-constructor')!.getAttribute('data-orientation') as EOrientation

  const pages = new Pages(orientation, utils.getTemplateForPage(docHtml));

  // await Promise.all([...docHtmlDOM.querySelectorAll('img') ?? []].map((imgElem) => new Promise((res, rej) => imgElem.onload = res)))

  // Чтобы избежать гонку промисов
  await allRowElems.reduce(async (promise, rowElem) => (
    promise.then(() => pages.insertElem(rowElem))
  ), Promise.resolve());

  utils.removeHiddenDom()

  return utils.getTemplateHTML(docHtml).replace('{{html}}', pages.pagesContent)
}