import { createIframe } from "./createIframe"

export const createHiddenDom = async (docHtml: string, selector: string = 'hidden-dom') => (
  new Promise<HTMLDivElement>((res, rej) => {

    const onLoad = (iframe: HTMLIFrameElement) => {
      try {
        const shadowContainer = window.document.createElement('div')

        shadowContainer.classList.add(selector)

        const parser = new DOMParser()
        const doc = parser.parseFromString(docHtml, 'text/html')

        shadowContainer.appendChild(doc.querySelector('html')!)

        iframe.contentDocument!.body.appendChild(shadowContainer)

        res(shadowContainer)
      } catch (error) {
        rej(error)
      }
    }

    createIframe('body', 'iframe-hidden-dom', onLoad)
  })
)