const path = require('path')

const isDev = process.env.NODE_ENV === 'development'

module.exports = {
  entry: './src/index.ts',
  devtool: isDev ? 'inline-source-map' : false,
  mode: process.env.NODE_ENV,
  output: {
    filename: 'index.js',
    path: path.resolve(__dirname, 'dist'),
    library: 'DocAdapter',
    libraryExport: 'default',
    libraryTarget: 'umd',
    umdNamedDefine: true,
    globalObject: 'typeof self === \'undefined\' ? this : self',
  },
  resolve: {
    extensions: ['.ts']
  },
  module: {
    rules: [{
      test: /\.ts$/,
      exclude: /node_modules/,
      use: ['babel-loader', 'ts-loader'],
    }]
  },
  // plugins: [new ESLintPlugin({ extensions: ['ts'] })], 
}